/*
// Created by Tiny on 3/3/2021.
*/
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include "GAME.h"
#include "prof.h"
#include "personnage.h"
#include "map.h"
#include "DS.h"

#define WINDOW_WIDTH (700)
#define WINDOW_HEIGHT (700)

int testposition(Personnage * pers, Prof * prof, DS * exam, MAP * map, int up,int down, int left, int right){
    int x_A=0,x_B=0,y_A=0,y_B=0;

    //calculer les points
    if (up && !down) {
        x_A= pers->x_pers;
        y_A = pers->y_pers;
        x_B = pers->x_pers + pers->larg_pers;
        y_B = pers->y_pers;
    }
    if (down && !up) {
        x_A= pers->x_pers;
        y_A = pers->y_pers + pers->long_pers;
        x_B = pers->x_pers + pers->larg_pers;
        y_B = pers->y_pers + pers->long_pers;
    }
    if (left && !right) {
        x_A= pers->x_pers;
        y_A = pers->y_pers;
        x_B= pers->x_pers;
        y_B = pers->y_pers + pers->long_pers;
    }
    if (right && !left) {
        x_A = pers->x_pers + pers->larg_pers;
        y_A = pers->y_pers;
        x_B = pers->x_pers + pers->larg_pers;
        y_B = pers->y_pers + pers->long_pers;
    }



    //test variables
    int testbounds = testboundscol(pers); ;
    int testprof = testprofcol(pers,prof,x_A,y_A,x_B,y_B);



    //test bounds collision

    if(testbounds) return 4;

	//test prof collision

    if(testprof) return 3;

    //return the map test position

    return testmapcol(pers,map,exam,x_A,y_A,x_B,y_B); // = 0 if nothing , 1 if wall, 2 if exam

}

int testboundscol(Personnage * pers){
    if((pers->x_pers <= 0) || (pers->y_pers <= 0) || (pers->x_pers >= WINDOW_WIDTH - pers->larg_pers) || (pers->y_pers >= WINDOW_HEIGHT - pers->long_pers)) {
        return 1;
    }
    return 0;
}

int testprofcol(Personnage * pers, Prof * prof,int x_A,int y_A, int x_B, int y_B){

    //test position vs prof
    if (( x_A > prof->x_prof) && (x_A<prof->x_prof+prof->larg_prof)) {
        if (( y_A > prof->y_prof) && (y_A < prof->y_prof + prof->long_prof)) {
            return 1;
        }
    }
    if (( x_B > prof->x_prof) && (x_B<prof->x_prof+prof->larg_prof)) {
        if (( y_B > prof->y_prof) && (y_B < prof->y_prof + prof->long_prof)) {
            return 1;
        }
    }

    return 0;
}

int testmapcol(Personnage * pers,  MAP * map, DS * exam ,int x_A,int y_A, int x_B, int y_B){


    if (map->functional[y_A][x_A] == 2){         //if zone exams
        //test exam collision
        if ((x_A > exam->x_DS) && (x_A < exam->x_DS+exam->larg_DS)) {
                return 2;
        }
    }
    else if (map->functional[y_A][x_A] == 1){         //if zone wall
        return 1;
    }

    if (map->functional[y_B][x_B] == 2){         //if zone exams
        //test exam collision
        if ((x_B > exam->x_DS) && (x_B < exam->x_DS+exam->larg_DS)) {
            return 2;
        }
    }
    else if (map->functional[y_B][x_B] == 1){         //if zone wall
        return 1;
    }
    return 0;        //if nothing
}